#!/usr/bin/env python

"""
sorter-2.py

Aufbau der Datei names.tsv
nconst
primaryName
birthYear
deathYear
imaryProfession
knownForTitles 
"""

from timeit import timeit
import sys
sys.setrecursionlimit(15000)

def get_data(filename, maxlines=False):
  "lies Datei filename, optionaler Parameter maxlines: # Zeilen"
  liste = []
  namefile = open(filename,"r")
  namefile.readline() #  erste Zeile ueberspringen
  linecount = 0
  for f in namefile:
    eintrag = f[:-1].split("\t")
    liste.append(eintrag)
    linecount += 1
    if (maxlines != False) and linecount >= maxlines:
      break
  namefile.close()
  return liste

def ausgabe(eintrag):
  "erzeuge formatierte Ausgabe von Name, Geburts- und Todesjahr"
  print(f"{eintrag[1]:30} {eintrag[2]:4}-{eintrag[3]:4}")

@timeit
def builtinsort(l, key):
  l.sort(key=key)

# @timeit
# def insertsort(l, key):
## TODO

@timeit
def bubblesort(l, key):
  anzahl = len(l)
  while True:
    vertauscht = False
    for i in range(anzahl-2,-1,-1):
      if key(l[i]) > key(l[i+1]):  # tauschen!
        l[i],l[i+1] = l[i+1],l[i]  
        vertauscht = True
    if not vertauscht: break

def partition(array, low, high, key):
  """Hilfsfunktion für Quicksort, Quelle: 
  https://www.geeksforgeeks.org/python-program-for-quicksort/ 
  vgl. auch Cormen et al., Algorithmen, S. 172 """
  pivot = array[high]
  i = low - 1
  for j in range(low, high):
    if key(array[j]) <= key(pivot):
      i = i + 1
      (array[i], array[j]) = (array[j], array[i])
  (array[i + 1], array[high]) = (array[high], array[i + 1])
  return i + 1

def quicksort_3params(array, low, high, key):
  """Quicksort, Quelle: 
  https://www.geeksforgeeks.org/python-program-for-quicksort/ """
  if low < high:
    pi = partition(array, low, high, key)
    quicksort_3params(array, low, pi - 1, key)
    quicksort_3params(array, pi + 1, high, key)

@timeit
def quicksort(l, key):
  laenge = len(l)
  quicksort_3params(l, 0, laenge-1, key)

# Key-Funktion: geburtsjahr()
def geburtsjahr(eintrag): return eintrag[2]

# Aufgabe c), Key-Funktion: name()
##
## TODO

def benchmark(size):
  print ("Benchmark: size =", size)
  orig_liste = get_data("names.tsv", size)

  liste = list(orig_liste)
  builtinsort(liste, key=geburtsjahr)  # sortieren nach Geb.-Jahr

  ## TODO: aktivieren, wenn insertsort() implementiert wurde
  # liste = list(orig_liste)
  # insertsort(liste, key=geburtsjahr)   # sortieren nach Geb.-Jahr

  liste = list(orig_liste)
  bubblesort(liste, key=geburtsjahr)   # sortieren nach Geb.-Jahr

  liste = list(orig_liste)
  quicksort(liste, key=geburtsjahr)    # sortieren nach Geb.-Jahr

for size in [1000,2000,3000,4000,5000,6000,7000,8000]:
  benchmark(size)

