# source: https://dev.to/kcdchennai/python-decorator-to-measure-execution-time-54hk
# (leicht angepasst)

from functools import wraps
import time

def timeit(func):
    @wraps(func)
    def timeit_wrapper(*args, **kwargs):
        start_time = time.perf_counter()
        result = func(*args, **kwargs)
        end_time = time.perf_counter()
        total_time = end_time - start_time
        print(f'{total_time:10.6f} s in function {func.__name__}()')
        return result
    return timeit_wrapper


